package com.example.julian.endlessroll.entities.tileLists;

import com.example.julian.endlessroll.data.Vector;
import com.example.julian.endlessroll.entities.Entity;
import com.example.julian.endlessroll.entities.textures.Texture;
import com.example.julian.endlessroll.levels.TileData;

/**
 * Created by Julian on 18.12.2015.
 */

public class Tile extends Entity {

    public Tile(TileList.Type type, Texture texture, float edge, TileData data) {
        this(type, texture, edge, data.getX(), data.getWidth());
    }

    public Tile(TileList.Type type, Texture texture, float edge, float x, float width) {
        super(texture, new Vector(), width, 0);
        super.height = type.calculateTileHeightFromEdge(edge);
        super.position.x = x;
        switch (type) {
            case TERRAIN:
                super.position.y = edge - super.height / 2;
                break;
            case CEILING:
                super.position.y = edge + super.height / 2;
                break;
        }
    }

}
