package com.example.julian.endlessroll.entities.tools;

import com.example.julian.endlessroll.data.Vector;
import com.example.julian.endlessroll.entities.Player;
import com.example.julian.endlessroll.entities.collision.geometry.Geometry;
import com.example.julian.endlessroll.entities.collision.geometry.Quad;
import com.example.julian.endlessroll.main.game.Timer;

/**
 * Created by Julian on 04.01.2016.
 */
public class Spring extends Tool {

    private boolean hasYetCollided = false;

    public Spring(Vector position) {
        super(ToolType.SPRING, position, .3f, .35f, true, true);
        animation.setIndexSequence(new int[]{1, 0, 0, 3, 3, 3, 1});
        animation.setRequiredDelta(80);
    }

    @Override
    public void update(Timer timer) {
        if (hasYetCollided)
            super.update(timer);
    }

    @Override
    public void onPlayerCollision(Player player) {
        if (!hasYetCollided) {
            hasYetCollided = true;
            player.getMovement().y = .0022f;
        }
    }

    @Override
    protected Geometry createCollisionBounds() {
        return new Quad(super.getPosition(), .2f, .2f);
    }
}
