package com.example.julian.endlessroll.entities.tools;

import com.example.julian.endlessroll.levels.levelup.LevelUpBounties;

import java.util.ArrayList;

/**
 * Created by Julian on 15.07.2016.
 */
public class ToolSlotSettings extends ArrayList<ToolSlot> {

    public ToolSlotSettings(String slot1, String slot2, String slot3, String slot4, int slotsLocked) throws Exception {
        super.add(new ToolSlot(ToolType.valueOf(slot1), false));
        super.add(new ToolSlot(ToolType.valueOf(slot2), slotsLocked < 3));
        super.add(new ToolSlot(ToolType.valueOf(slot3), slotsLocked < 2));
        super.add(new ToolSlot(ToolType.valueOf(slot4), slotsLocked < 1));
    }

    public void reset() {
        super.set(0, new ToolSlot(ToolType.RAMP, false));
        super.set(1, new ToolSlot(ToolType.NONE, true));
        super.set(2, new ToolSlot(ToolType.NONE, true));
        super.set(3, new ToolSlot(ToolType.NONE, true));
    }

    public void changeToolSlotType(int slot, ToolType newType) {
        for (ToolSlot toolSlot : this) {
            if (super.indexOf(toolSlot) == slot)
                toolSlot.setToolType(newType);
            else if (toolSlot.getToolType() == newType)
                toolSlot.setToolType(ToolType.NONE);
        }
    }

    public void unlockSlotsIfLevelReached(LevelUpBounties levelUpBounties) {
        for (int i = 0; i < 4; i++)
            super.get(i).setLocked(levelUpBounties.isToolSlotLocked(i));
    }

    public int getLockedSlotCount() {
        for (int i = super.size() - 1; i > 0; i--) {
            if (!super.get(i).isLocked())
                return i + 1;
        }
        return 0;
    }

}
