package com.example.julian.endlessroll.levels;

import com.example.julian.endlessroll.data.Vector;
import com.example.julian.endlessroll.entities.Vertex;

import org.simpleframework.xml.Attribute;

public class MoveComponent {

    @Attribute
    private float width;
    @Attribute
    private float height;
    @Attribute
    private float x;
    @Attribute
    private float y;
    @Attribute
    private float speed;

    public float getWidth() {
        return width;
    }

    public float getHeight() {
        return height;
    }

    public float getX() {
        return x;
    }

    public float getY() {
        return y;
    }

    public float getSpeed() {
        return speed;
    }

    public Vector getPositionOfVertex(Vertex vertex) {
        float x = this.x + (width / 2f) * vertex.getX();
        float y = this.y + (height / 2f) * vertex.getY();
        return new Vector(x, y);
    }

    public void shrink(Vector value) {
        this.width -= value.getX();
        this.height -= value.getY();
        if (width < 0)
            width = 0;
        if (height < 0)
            height = 0;
    }

}
