package com.example.julian.endlessroll.views;

import android.content.Context;
import android.support.annotation.DrawableRes;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.example.julian.endlessroll.R;
import com.example.julian.endlessroll.main.screens.Screen;

/**
 * Created by Julian on 15.07.2016.
 */
public class BountyMessage implements View.OnClickListener {

    public interface ScreenSwitchCaller {
        public void switchScreen(Screen.ScreenType screenType);
    }

    private LinearLayout layout;
    private ImageView image;
    private TextView text;

    private ScreenSwitchCaller screenSwitchCaller;
    private Screen.ScreenType goalScreen;

    public BountyMessage(Context context, @DrawableRes int drawableId, String text, ScreenSwitchCaller screenSwitchCaller, Screen.ScreenType goalScreenType) {
        findViews(context);
        this.image.setImageResource(drawableId);
        this.text.setText(text);
        this.screenSwitchCaller = screenSwitchCaller;
        this.goalScreen = goalScreenType;
    }

    private void findViews(Context context) {
        LayoutInflater inflater = LayoutInflater.from(context);
        layout = (LinearLayout) inflater.inflate(R.layout.unlock_message, null);
        layout.setOnClickListener(this);
        image = (ImageView) layout.findViewById(R.id.unlockmessage_toolimage);
        text = (TextView) layout.findViewById(R.id.unlockmessage_message);
    }

    @Override
    public void onClick(View v) {
        if (goalScreen != Screen.ScreenType.NONE)
            screenSwitchCaller.switchScreen(goalScreen);
    }

    public LinearLayout getLayout() {
        return layout;
    }
}
